View Issue Details

IDProjectCategoryView StatusLast Update
0000570Database Comparer utilityGeneralpublic2019-12-27 13:25
Reportershirokov Assigned Tobarry  
PrioritynormalSeveritymajorReproducibilityalways
Status resolvedResolutionfixed 
Platform64bitOSwin 
Fixed in Version8.0.0.1902.Beta 
Summary0000570: Table data comparing produces corrupted result.sql file
DescriptionПри попытке сравнить табличные данные в двух базах (DDL скрипты можно скачать по ссылке ниже, я не смог их приаттачить в баг-репорт) result.sql сохраняется в поврежденном виде - строчки стейтментов оборваны, файл похож на юникод - двухбайтная кодировка, но префикса fe ff нет. (файл там же)

http://www.clevercomponents.com/dev/dbc/support/SQL2008CompoundOperators/tabledatacomp.zip
Steps To Reproduce1. создать 2 базы
2. прогнать скрипты
3. настроить компарер на закладке Table data comparer
4. результирующий скрипт отображается в окне компарера корректно, а в файле result.sql нет
Additional InformationDatabase Comparer Standalone v 6.1 64 bit
ms sql 2008 r2 express
TagsNo tags attached.

Activities

shirokov

2013-09-04 22:23

administrator   ~0001384

После анализа исходного кода, выяснилось, что
проблему вызывает способ записи в поток в методе TTableDataComparer.DoAddResultSQL:
fScriptStream.WriteBuffer(aSQL[1], Length(aSQL));

в юникодной дельфи размер вдвое больше, поэтому стейтменты недописаны.

barry

2019-12-25 11:03

administrator   ~0004281

Сейчас пишет однобайтный ANSI (с нормальными строками). Но наверное это не совсем правильно, надо писать Unicode?

barry

2019-12-25 11:03

administrator   ~0004282

Tested on 2014.

barry

2019-12-25 11:08

administrator   ~0004283

x32 пишет нормальный ANSI, x64 действительно странный файл делает

barry

2019-12-25 12:52

administrator   ~0004284

непонятно..
Теперь x64 записал корректный ANSI но без GO, с разделителями ";" (как для IB/FB).
По записи ничего вроде не трогал. Убрал из проекта использование RX, заменил контролы на JVCL.

Issue History

Date Modified Username Field Change
2013-09-04 20:29 shirokov New Issue
2013-09-04 22:23 shirokov Note Added: 0001384
2019-12-25 10:43 barry Assigned To => barry
2019-12-25 10:43 barry Status new => acknowledged
2019-12-25 11:03 barry Note Added: 0004281
2019-12-25 11:03 barry Note Added: 0004282
2019-12-25 11:08 barry Note Added: 0004283
2019-12-25 12:52 barry Note Added: 0004284
2019-12-25 19:17 barry Status acknowledged => resolved
2019-12-25 19:17 barry Resolution open => fixed
2019-12-25 19:17 barry Fixed in Version => 8.0.0.1748
2019-12-26 20:30 barry Status resolved => acknowledged
2019-12-27 13:25 barry Status acknowledged => resolved
2019-12-27 13:25 barry Fixed in Version 8.0.0.1748 => 8.0.0.1902.Beta